Attribute VB_Name = "Modul1"
Option Explicit
Dim dblBoreholeX() As Double
Dim dblBoreholeY() As Double
Dim dblBoreholeZ() As Double
Dim dblBoreholeV() As Double
Dim lngBoreholeNumber() As Long
Dim lngNumberMeasures As Long

Dim dblBoreholeSort() As Double
Dim dblLocX() As Double
Dim dblLocY() As Double
Dim dblLocTop() As Double
Dim dblLocBot() As Double
Dim lngNumberLoc As Long

Dim lngNumberSlices As Long
Sub select_datasource()
'Program to select the datasource for boreholes
'(C) Wolfgang Gossel, Martin Luther University Halle, 2009
UserForm3.Show
End Sub
Sub use_sorted_dataset()
Dim intBoreHeightAttribField As Integer
Dim intBoreConcAttribField As Integer
Dim intBoreIDAttribField As Integer
Dim lngCounter1 As Long
Dim lngCounter2 As Long
Dim lngNumberLayers As Long
Dim lngCounterLayer As Long
Dim lngNumberMaps As Long
Dim lngNumberFields As Long

Dim lngBoreLayerID As Long
Dim dblTmp As Double

Dim docWGMxDoc As IMxDocument
Dim flWGBoreholeLayer As IFeatureLayer
Dim fWGBoreholeFeature As IFeature
Dim fclWGBoreholeFeatureClass As IFeatureClass
Dim fsWGBoreholeSelection As IFeatureSelection
Dim fcWGBoreholeFeatureCursor As IFeatureCursor
Dim pWGBorehole As IPoint


Set docWGMxDoc = ThisDocument

lngNumberLayers = docWGMxDoc.FocusMap.LayerCount

UserForm4.cmbBoreShape.Clear

For lngCounterLayer = 0 To lngNumberLayers - 1
    UserForm4.cmbBoreShape.AddItem docWGMxDoc.FocusMap.Layer(lngCounterLayer).Name
Next


UserForm4.Show

lngBoreLayerID = UserForm4.cmbBoreShape.ListIndex
intBoreHeightAttribField = UserForm4.cmbBoreHeightField.ListIndex
intBoreConcAttribField = UserForm4.cmbBoreConcField.ListIndex
intBoreIDAttribField = UserForm4.cmbBoreIDField.ListIndex

Set flWGBoreholeLayer = docWGMxDoc.FocusMap.Layer(lngBoreLayerID)
lngNumberMeasures = flWGBoreholeLayer.FeatureClass.FeatureCount(Nothing)

ReDim dblBoreholeX(lngNumberMeasures) As Double
ReDim dblBoreholeY(lngNumberMeasures) As Double
ReDim dblBoreholeZ(lngNumberMeasures) As Double
ReDim dblBoreholeV(lngNumberMeasures) As Double
ReDim lngBoreholeNumber(lngNumberMeasures) As Long
ReDim dblBoreholeSort(lngNumberMeasures) As Double

Set fclWGBoreholeFeatureClass = flWGBoreholeLayer.FeatureClass
Set fcWGBoreholeFeatureCursor = fclWGBoreholeFeatureClass.Update(Nothing, False)
Set fWGBoreholeFeature = fcWGBoreholeFeatureCursor.NextFeature

For lngCounter1 = 0 To lngNumberMeasures - 1
    Set pWGBorehole = fWGBoreholeFeature.Shape
    dblBoreholeX(lngCounter1) = pWGBorehole.X
    dblBoreholeY(lngCounter1) = pWGBorehole.Y
    dblBoreholeZ(lngCounter1) = fWGBoreholeFeature.Value(intBoreHeightAttribField)
    dblBoreholeV(lngCounter1) = fWGBoreholeFeature.Value(intBoreConcAttribField)
    lngBoreholeNumber(lngCounter1) = fWGBoreholeFeature.Value(intBoreIDAttribField)
    Set fWGBoreholeFeature = fcWGBoreholeFeatureCursor.NextFeature
Next

lngCounter2 = 0

For lngCounter1 = 0 To lngNumberMeasures - 1
    If (lngBoreholeNumber(lngCounter1) <> lngBoreholeNumber(lngCounter1 + 1)) Then
        lngCounter2 = lngCounter2 + 1
    End If
Next

lngNumberLoc = lngCounter2

ReDim dblLocX(lngNumberLoc) As Double
ReDim dblLocY(lngNumberLoc) As Double
ReDim dblLocTop(lngNumberLoc) As Double
ReDim dblLocBot(lngNumberLoc) As Double

lngCounter1 = 0

dblLocTop(lngCounter1) = -999999
dblLocBot(lngCounter1) = 999999

For lngCounter2 = 0 To lngNumberMeasures - 1
    If (lngBoreholeNumber(lngCounter2) = lngBoreholeNumber(lngCounter2 + 1)) Then
        If (dblBoreholeZ(lngCounter2) > dblLocTop(lngCounter1)) Then
           dblLocTop(lngCounter1) = dblBoreholeZ(lngCounter2)
        End If
        
        If (dblBoreholeZ(lngCounter2) < dblLocBot(lngCounter1)) Then
            dblLocBot(lngCounter1) = dblBoreholeZ(lngCounter2)
        End If
    Else
        If (dblBoreholeZ(lngCounter2) > dblLocTop(lngCounter1)) Then
           dblLocTop(lngCounter1) = dblBoreholeZ(lngCounter2)
        End If
        
        If (dblBoreholeZ(lngCounter2) < dblLocBot(lngCounter1)) Then
            dblLocBot(lngCounter1) = dblBoreholeZ(lngCounter2)
        End If
        dblLocX(lngCounter1) = dblBoreholeX(lngCounter2)
        dblLocY(lngCounter1) = dblBoreholeY(lngCounter2)
        lngCounter1 = lngCounter1 + 1
        dblLocTop(lngCounter1) = -999999
        dblLocBot(lngCounter1) = 999999
    End If
Next

create_borehole_layer

prepare_slices

End Sub
Sub height_conc_intervals()

'Program to prepare the borehole data as input for 3D statistical
'interpolation
'(C) Wolfgang Gossel, Martin Luther University Halle, 2009

Dim intBoreHeightAttribField As Integer
Dim intBoreConcAttribField As Integer
Dim lngCounter1 As Long
Dim lngCounter2 As Long
Dim lngNumberLayers As Long
Dim lngCounterLayer As Long
Dim lngNumberMaps As Long
Dim lngNumberFields As Long

Dim lngBoreLayerID As Long
Dim dblTmp As Double

Dim docWGMxDoc As IMxDocument
Dim flWGBoreholeLayer As IFeatureLayer
Dim fWGBoreholeFeature As IFeature
Dim fclWGBoreholeFeatureClass As IFeatureClass
Dim fsWGBoreholeSelection As IFeatureSelection
Dim fcWGBoreholeFeatureCursor As IFeatureCursor
Dim pWGBorehole As IPoint


Set docWGMxDoc = ThisDocument

lngNumberLayers = docWGMxDoc.FocusMap.LayerCount

UserForm1.cmbBoreShape.Clear

For lngCounterLayer = 0 To lngNumberLayers - 1
    UserForm1.cmbBoreShape.AddItem docWGMxDoc.FocusMap.Layer(lngCounterLayer).Name
Next


UserForm1.Show

lngBoreLayerID = UserForm1.cmbBoreShape.ListIndex
intBoreHeightAttribField = UserForm1.cmbBoreHeightField.ListIndex
intBoreConcAttribField = UserForm1.cmbBoreConcField.ListIndex

Set flWGBoreholeLayer = docWGMxDoc.FocusMap.Layer(lngBoreLayerID)
lngNumberMeasures = flWGBoreholeLayer.FeatureClass.FeatureCount(Nothing)

ReDim dblBoreholeX(lngNumberMeasures) As Double
ReDim dblBoreholeY(lngNumberMeasures) As Double
ReDim dblBoreholeZ(lngNumberMeasures) As Double
ReDim dblBoreholeV(lngNumberMeasures) As Double
ReDim lngBoreholeNumber(lngNumberMeasures) As Long
ReDim dblBoreholeSort(lngNumberMeasures) As Double

Set fclWGBoreholeFeatureClass = flWGBoreholeLayer.FeatureClass
Set fcWGBoreholeFeatureCursor = fclWGBoreholeFeatureClass.Update(Nothing, False)
Set fWGBoreholeFeature = fcWGBoreholeFeatureCursor.NextFeature

'Get borehole data from Shape file

For lngCounter1 = 0 To lngNumberMeasures - 1
    Set pWGBorehole = fWGBoreholeFeature.Shape
    dblBoreholeX(lngCounter1) = pWGBorehole.X
    dblBoreholeY(lngCounter1) = pWGBorehole.Y
    dblBoreholeZ(lngCounter1) = fWGBoreholeFeature.Value(intBoreHeightAttribField)
    dblBoreholeV(lngCounter1) = fWGBoreholeFeature.Value(intBoreConcAttribField)
    dblTmp = dblBoreholeX(lngCounter1) Mod (1000000)
    dblBoreholeSort(lngCounter1) = (dblTmp * 10000000) + CLng(dblBoreholeY(lngCounter1))
    Set fWGBoreholeFeature = fcWGBoreholeFeatureCursor.NextFeature
Next

'Sort borehole data according to X and Y

For lngCounter1 = 0 To lngNumberMeasures - 1
    For lngCounter2 = 0 To lngNumberMeasures - lngCounter1 - 1
        If (dblBoreholeSort(lngCounter2) > dblBoreholeSort(lngCounter2 + 1)) Then
            dblTmp = dblBoreholeSort(lngCounter2)
            dblBoreholeSort(lngCounter2) = dblBoreholeSort(lngCounter2 + 1)
            dblBoreholeSort(lngCounter2 + 1) = dblTmp
            dblTmp = dblBoreholeX(lngCounter2)
            dblBoreholeX(lngCounter2) = dblBoreholeX(lngCounter2 + 1)
            dblBoreholeX(lngCounter2 + 1) = dblTmp
            dblTmp = dblBoreholeY(lngCounter2)
            dblBoreholeY(lngCounter2) = dblBoreholeY(lngCounter2 + 1)
            dblBoreholeY(lngCounter2 + 1) = dblTmp
            dblTmp = dblBoreholeZ(lngCounter2)
            dblBoreholeZ(lngCounter2) = dblBoreholeZ(lngCounter2 + 1)
            dblBoreholeZ(lngCounter2 + 1) = dblTmp
            dblTmp = dblBoreholeV(lngCounter2)
            dblBoreholeV(lngCounter2) = dblBoreholeV(lngCounter2 + 1)
            dblBoreholeV(lngCounter2 + 1) = dblTmp
        End If
    Next
Next

'Count boreholes

lngCounter2 = 0
lngBoreholeNumber(0) = 0

For lngCounter1 = 0 To lngNumberMeasures - 1
    If (dblBoreholeSort(lngCounter1) <> dblBoreholeSort(lngCounter1 + 1)) Then
        lngCounter2 = lngCounter2 + 1
    End If
    lngBoreholeNumber(lngCounter1) = lngCounter2
Next

lngNumberLoc = lngCounter2

ReDim dblLocX(lngNumberLoc) As Double
ReDim dblLocY(lngNumberLoc) As Double
ReDim dblLocTop(lngNumberLoc) As Double
ReDim dblLocBot(lngNumberLoc) As Double

lngCounter1 = 0

dblLocTop(lngCounter1) = -999999
dblLocBot(lngCounter1) = 999999

For lngCounter2 = 0 To lngNumberMeasures - 1
    If (dblBoreholeSort(lngCounter2) = dblBoreholeSort(lngCounter2 + 1)) Then
        If (dblBoreholeZ(lngCounter2) > dblLocTop(lngCounter1)) Then
           dblLocTop(lngCounter1) = dblBoreholeZ(lngCounter2)
        End If
        
        If (dblBoreholeZ(lngCounter2) < dblLocBot(lngCounter1)) Then
            dblLocBot(lngCounter1) = dblBoreholeZ(lngCounter2)
        End If
    Else
        If (dblBoreholeZ(lngCounter2) > dblLocTop(lngCounter1)) Then
           dblLocTop(lngCounter1) = dblBoreholeZ(lngCounter2)
        End If
        
        If (dblBoreholeZ(lngCounter2) < dblLocBot(lngCounter1)) Then
            dblLocBot(lngCounter1) = dblBoreholeZ(lngCounter2)
        End If
        dblLocX(lngCounter1) = dblBoreholeX(lngCounter2)
        dblLocY(lngCounter1) = dblBoreholeY(lngCounter2)
        lngCounter1 = lngCounter1 + 1
        dblLocTop(lngCounter1) = -999999
        dblLocBot(lngCounter1) = 999999
    End If
Next

create_borehole_layer

prepare_slices

End Sub

Sub create_borehole_layer()

Dim lngCounter1 As Long
Dim lngCounter2 As Long
Dim lngNumberLayers As Long
Dim lngCounterLayer As Long
Dim lngNumberMaps As Long
Dim lngNumberFields As Long

Dim lngBoreLayerID As Long
Dim dblTmp As Double

Dim docWGMxDoc As IMxDocument
Dim flWGBoreholeLayer As IFeatureLayer
Dim fWGBoreholeFeature As IFeature
Dim fclWGBoreholeFeatureClass As IFeatureClass
Dim fsWGBoreholeSelection As IFeatureSelection
Dim fcWGBoreholeFeatureCursor As IFeatureCursor
Dim pWGBorehole As IPoint
Dim flWGBoreLoc As IFeatureLayer
Dim fclWGBoreLoc As IFeatureClass
Dim fldWGBoreLocX As IField
Dim fldWGBoreLocY As IField
Dim fldeWGBoreLocX As IFieldEdit
Dim fldsWGBoreLocX As IFields
Dim fldeWGBoreLocY As IFieldEdit
Dim fldsWGBoreLocY As IFields

Dim fldWGBoreLocBot As IField
Dim fldWGBoreLocTop As IField
Dim fldeWGBoreLocBot As IFieldEdit
Dim fldsWGBoreLocBot As IFields
Dim fldeWGBoreLocTop As IFieldEdit
Dim fldsWGBoreLocTop As IFields

Dim fcWGBoreLoc As IFeatureCursor
Dim fbWGBoreLoc As IFeatureBuffer
Dim pWGBoreLoc As IPoint
Dim mpWGBoreLocMap As IMap
Dim fclnWGInBoreLoc As IFeatureClassName
Dim fclnWGOutBoreLoc As IFeatureClassName
Dim dsWGInBoreLoc As IDataset
Dim dsWGOutBoreLoc As IDataset
Dim dsnWGIn As IDatasetName
Dim dsnWGBoreLoc As IDatasetName
Dim fsWGBoreLoc As IFeatureSelection
Dim ssWGBoreLoc As ISelectionSet
Dim wsfWGBoreLoc As IWorkspaceFactory
Dim wsnWGBoreLoc As IWorkspaceName
Dim wsWGBoreLoc As IFeatureWorkspace
Dim pExportOp As IExportOperation


Set docWGMxDoc = ThisDocument

Set mpWGBoreLocMap = docWGMxDoc.FocusMap
Set flWGBoreLoc = mpWGBoreLocMap.Layer(0)

Set fclWGBoreLoc = flWGBoreLoc.FeatureClass

Set fldWGBoreLocX = New Field

Set fldWGBoreLocY = New Field

Set fldWGBoreLocBot = New Field

Set fldWGBoreLocTop = New Field

Set fldeWGBoreLocX = fldWGBoreLocX
fldeWGBoreLocX.Name = "X"
fldeWGBoreLocX.Type = esriFieldTypeDouble

Set fldsWGBoreLocX = fclWGBoreLoc.Fields
fclWGBoreLoc.AddField fldWGBoreLocX

Set fldeWGBoreLocY = fldWGBoreLocY
fldeWGBoreLocY.Name = "Y"
fldeWGBoreLocY.Type = esriFieldTypeDouble

Set fldsWGBoreLocY = fclWGBoreLoc.Fields
fclWGBoreLoc.AddField fldWGBoreLocY


Set fldeWGBoreLocBot = fldWGBoreLocBot
fldeWGBoreLocBot.Name = "Top"
fldeWGBoreLocBot.Type = esriFieldTypeDouble

Set fldsWGBoreLocBot = fclWGBoreLoc.Fields
fclWGBoreLoc.AddField fldWGBoreLocBot

Set fldeWGBoreLocTop = fldWGBoreLocTop
fldeWGBoreLocTop.Name = "Bottom"
fldeWGBoreLocTop.Type = esriFieldTypeDouble

Set fldsWGBoreLocTop = fclWGBoreLoc.Fields
fclWGBoreLoc.AddField fldWGBoreLocTop

Set fsWGBoreLoc = flWGBoreLoc
Set ssWGBoreLoc = fsWGBoreLoc.SelectionSet
Set dsWGInBoreLoc = fclWGBoreLoc
Set fclnWGInBoreLoc = dsWGInBoreLoc.FullName
Set dsnWGIn = fclnWGInBoreLoc

Set fclnWGOutBoreLoc = New FeatureClassName
Set dsnWGBoreLoc = fclnWGOutBoreLoc
dsnWGBoreLoc.Name = "Borehole_Locations"
Set wsnWGBoreLoc = New WorkspaceName
wsnWGBoreLoc.PathName = InputBox("Please set path of new shape file (e.g. c:\temp\):")
wsnWGBoreLoc.WorkspaceFactoryProgID = "esriCore.shapefileworkspacefactory.1"
Set dsnWGBoreLoc.WorkspaceName = wsnWGBoreLoc
fclnWGOutBoreLoc.FeatureType = esriFTSimple
fclnWGOutBoreLoc.ShapeType = esriGeometryPoint
fclnWGOutBoreLoc.ShapeFieldName = "Shape"
Set pExportOp = New ExportOperation
pExportOp.ExportFeatureClass dsnWGIn, Nothing, ssWGBoreLoc, Nothing, dsnWGBoreLoc, 0

Set wsfWGBoreLoc = New ShapefileWorkspaceFactory
Set wsWGBoreLoc = wsfWGBoreLoc.OpenFromFile(wsnWGBoreLoc.PathName, 0)
Dim pClass As IFeatureClass
Set pClass = wsWGBoreLoc.OpenFeatureClass("Borehole_Locations")

Dim pLayer As IFeatureLayer
Set pLayer = New FeatureLayer
Set pLayer.FeatureClass = pClass
pLayer.Name = pClass.AliasName
Dim pMxDoc As IMxDocument
Set pMxDoc = ThisDocument
pMxDoc.AddLayer pLayer
pMxDoc.ActiveView.PartialRefresh esriViewGeography, pLayer, Nothing

Set flWGBoreLoc = docWGMxDoc.FocusMap.Layer(0)
Set fclWGBoreLoc = flWGBoreLoc.FeatureClass

Set fcWGBoreLoc = fclWGBoreLoc.Insert(True)

Set fbWGBoreLoc = fclWGBoreLoc.CreateFeatureBuffer

For lngCounter1 = 0 To lngNumberLoc - 1
    Set pWGBoreLoc = New Point
    pWGBoreLoc.X = dblLocX(lngCounter1)
    pWGBoreLoc.Y = dblLocY(lngCounter1)
    fbWGBoreLoc.Value(3) = dblLocX(lngCounter1)
    fbWGBoreLoc.Value(4) = dblLocY(lngCounter1)
    fbWGBoreLoc.Value(5) = dblLocTop(lngCounter1)
    fbWGBoreLoc.Value(6) = dblLocBot(lngCounter1)
    fcWGBoreLoc.InsertFeature fbWGBoreLoc
Next

'prepare_slices

lngCounter1 = 0

End Sub

Sub prepare_slices()

'Program to prepare the slices for 3D statistical interpolation

'(C) Wolfgang Gossel, Martin Luther University Halle, 2009


Dim dblTopDataset As Double
Dim dblBottomDataset As Double
Dim lngCounter1 As Long
Dim lngCounter2 As Long
Dim lngCounter3 As Long
Dim dblTopSlices As Double
Dim dblBotSlices As Double
Dim dblDistanceSlices As Double
Dim dblVZSlice() As Double
Dim dblZSlice As Double
Dim dblVZSumTemp As Double
Dim dblZSumTemp As Double
Dim dblDistanceTemp As Double
Dim lngTmp As Long

Dim docWGDocument As IMxDocument
Dim mapWGMap As IMap
Dim flWGInterpol As IFeatureLayer
Dim fcWGInterpol As IFeatureClass
Dim fldWGInterpolZ As IField
Dim fldeWGInterpolZ As IFieldEdit
Dim fldWGInterpolV As IField
Dim fldeWGInterpolV As IFieldEdit
Dim fldsWGInterpolV As IFields
Dim curWGInterpol As IFeatureCursor
Dim fWGInterpol As IFeature

dblTopDataset = -999999
dblBottomDataset = 999999

For lngCounter1 = 0 To lngNumberMeasures
    
    If dblBoreholeZ(lngCounter1) < dblBottomDataset Then
        dblBottomDataset = dblBoreholeZ(lngCounter1)
    End If
    
    If dblBoreholeZ(lngCounter1) > dblTopDataset Then
        dblTopDataset = dblBoreholeZ(lngCounter1)
    End If
Next

UserForm2.lblBotData.Caption = "Bottom dataset: " & dblBottomDataset
UserForm2.lblTopData.Caption = "Top dataset: " & dblTopDataset
UserForm2.lblNumSlices.Caption = "Number of Slices for interpolation (max. 250):"

UserForm2.Show

dblTopSlices = UserForm2.txtTopEle.Value
dblBotSlices = UserForm2.txtBotEle.Value
lngNumberSlices = UserForm2.txtNumSlices.Value

Set docWGDocument = ThisDocument
Set mapWGMap = docWGDocument.FocusMap
Set flWGInterpol = mapWGMap.Layer(0)
Set fcWGInterpol = flWGInterpol.FeatureClass



dblDistanceSlices = (dblTopSlices - dblBotSlices) / lngNumberSlices
ReDim dblVZSlice(lngNumberLoc * lngNumberSlices) As Double


For lngCounter3 = 0 To lngNumberSlices - 1
    dblZSlice = dblBotSlices + (lngCounter3 * dblDistanceSlices)
    Set fldWGInterpolZ = New Field
    Set fldeWGInterpolZ = fldWGInterpolZ
    fldeWGInterpolZ.Name = "Z" & lngCounter3
    fldeWGInterpolZ.Type = esriFieldTypeDouble
    Set fldsWGInterpolV = fcWGInterpol.Fields
    fcWGInterpol.AddField fldWGInterpolZ
    Set fldWGInterpolV = New Field
    Set fldeWGInterpolV = fldWGInterpolV
    fldeWGInterpolV.Name = "V" & lngCounter3
    fldeWGInterpolV.Type = esriFieldTypeDouble
    Set fldsWGInterpolV = fcWGInterpol.Fields
    fcWGInterpol.AddField fldWGInterpolV
Next


For lngCounter3 = 0 To lngNumberSlices - 1
    dblZSlice = lngCounter3 * dblDistanceSlices
    For lngCounter1 = 0 To lngNumberLoc - 1
        For lngCounter2 = 0 To lngNumberMeasures - 1
            If lngBoreholeNumber(lngCounter2) = lngCounter1 Then
                dblDistanceTemp = ((dblBoreholeZ(lngCounter2) - dblZSlice) * (dblBoreholeZ(lngCounter2) - dblZSlice))
                If dblDistanceTemp = 0 Then
                    dblDistanceTemp = 0.001
                End If
                dblZSumTemp = dblZSumTemp + (dblBoreholeV(lngCounter2) / dblDistanceTemp)
                dblVZSumTemp = dblVZSumTemp + (1 / dblDistanceTemp)
            End If
        Next
        If dblVZSumTemp = 0 Then
        dblVZSlice(lngCounter3 * lngNumberLoc + lngCounter1) = dblZSumTemp / 1
        Else
        dblVZSlice(lngCounter3 * lngNumberLoc + lngCounter1) = dblZSumTemp / dblVZSumTemp
        End If
        dblZSumTemp = 0
        dblVZSumTemp = 0
    Next
Next


Set curWGInterpol = fcWGInterpol.Update(Nothing, False)
Set fWGInterpol = curWGInterpol.NextFeature

For lngCounter1 = 0 To lngNumberLoc - 2
    For lngCounter2 = 0 To lngNumberSlices - 1
        lngTmp = 7 + (2 * lngCounter2)
        fWGInterpol.Value(lngTmp) = dblBotSlices + (lngCounter2 * dblDistanceSlices)
        fWGInterpol.Value(lngTmp + 1) = dblVZSlice(lngCounter2 * lngNumberLoc + lngCounter1)
        curWGInterpol.UpdateFeature fWGInterpol
    Next
    Set fWGInterpol = curWGInterpol.NextFeature
Next

For lngCounter2 = 0 To lngNumberSlices - 1
        lngTmp = 7 + (2 * lngCounter2)
        fWGInterpol.Value(lngTmp) = dblBotSlices + (lngCounter2 * dblDistanceSlices)
        fWGInterpol.Value(lngTmp + 1) = dblVZSlice(lngCounter2 * lngNumberLoc + lngCounter1)
        curWGInterpol.UpdateFeature fWGInterpol
Next

lngCounter1 = 0

End Sub

Sub interpolate_slices()

'Start interpolation with kriging

Dim docWGDocument As IMxDocument
Dim mapWGMap As IMap
Dim flWGInterpol As IFeatureLayer
Dim fcWGInterpol As IFeatureClass
Dim fldWGInterpolZ As IField
Dim fldeWGInterpolZ As IFieldEdit
Dim fldWGInterpolV As IField
Dim fldeWGInterpolV As IFieldEdit
Dim fldsWGInterpolV As IFields
Dim curWGInterpol As IFeatureCursor
Dim fWGInterpol As IFeature

Dim strFieldNameRaster As String
Dim fcdWGInterpol As IFeatureClassDescriptor
Dim rlWGInterpol As IRasterLayer
Dim gdWGInterpol As IGeoDataset
Dim lngNumberLayers As Long
Dim lngCounter1 As Long
Dim lngCounter2 As Long

Dim iopWGInterpol As IInterpolationOp
Dim envWGInterpolation As IRasterAnalysisEnvironment
Dim radWGInterpolation As IRasterRadius
Dim gdWGOutRasterInterpolation As IGeoDataset

Dim rbcWGInterpolationRaster As IRasterBandCollection
Dim rbWGInterpolationKrige As IRasterBand
Dim rbcWGInterpolationKrige As IRasterBandCollection

Dim rlWGKrigeLayer As IRasterLayer

Set docWGDocument = ThisDocument
Set mapWGMap = docWGDocument.FocusMap

lngNumberLayers = docWGDocument.FocusMap.LayerCount
lngNumberSlices = 10

For lngCounter2 = 0 To lngNumberSlices - 1
    Set flWGInterpol = mapWGMap.Layer(lngCounter2)
    Set fcWGInterpol = flWGInterpol.FeatureClass

    strFieldNameRaster = "V" & lngCounter2
    Set fcdWGInterpol = New FeatureClassDescriptor
    fcdWGInterpol.Create fcWGInterpol, Nothing, strFieldNameRaster
    Set rlWGInterpol = mapWGMap.Layer(1 + lngCounter2)
    Set gdWGInterpol = rlWGInterpol.Raster

    Set iopWGInterpol = New RasterInterpolationOp
    Set envWGInterpolation = iopWGInterpol
    envWGInterpolation.SetCellSize esriRasterEnvValue, gdWGInterpol
    Set radWGInterpolation = New RasterRadius
    radWGInterpolation.SetVariable 12

    Set gdWGOutRasterInterpolation = iopWGInterpol.Krige(fcdWGInterpol, esriGeoAnalysisSphericalSemiVariogram, radWGInterpolation, True)

    Set rbcWGInterpolationRaster = gdWGOutRasterInterpolation
    Set rbWGInterpolationKrige = rbcWGInterpolationRaster.Item(0)
    Set rbcWGInterpolationKrige = New Raster
    rbcWGInterpolationKrige.AppendBand rbWGInterpolationKrige

    Set rlWGKrigeLayer = New RasterLayer
    rlWGKrigeLayer.CreateFromRaster rbcWGInterpolationKrige
    rlWGKrigeLayer.Name = "Layer" & lngCounter2
    mapWGMap.AddLayer rlWGKrigeLayer
Next

lngCounter1 = 0
End Sub
